<template>
  <div>
    <!--<template>
      <hsc-window-style-white>
        <hsc-window
          style=" z-index:2000"
          :resizable="true"
          :isScrollable="true"
          :minHeight="300"
          :maxHeight="500"
          :minWidth="300"
          :maxWidth="400"
          title="Viewer Objects"
          :width="400"
          :height="300"
        >
          <json-view :data="$data" />
        </hsc-window>
      </hsc-window-style-white>
    </template>-->
    <!--<template v-if="jsonView">
      <hsc-window-style-white>
        <hsc-window
          style=" z-index:2000"
          :resizable="true"
          :isScrollable="true"
          :minHeight="300"
          :maxHeight="500"
          :minWidth="300"
          :maxWidth="400"
          title="Viewer Objects"
          :width="400"
          :height="300"
        >
          <json-view :data="$v" />
        </hsc-window>
      </hsc-window-style-white>
    </template>-->
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>{{ textoGestionProtocolo }}</strong>
    </div>
    <div class="contSecc">
      <div v-if="!importExcel">
      <!--<v-btn
        :class="[
        {desac : !isDataTemp},
        {desac: protocoloTemp}
        ]"
        v-if="!protocoloTemp"
        @click.stop="visualizarInfo"
        small
        class="float-right"
        dark
        tile
        color="primary"
      >
        <v-avatar size="20" tile>
          <v-img
            :contain="true"
            :aspect-ratio="1"
            position="center"
            src="@/assets/img/visualizar.svg"
            class="black--text ml-5"
          ></v-img> </v-avatar
        >
        <template v-if="isDataTemp">Visualizar datos locales</template>
        <template v-else>Visualizar datos</template>
      </v-btn>-->
      <v-btn
        @click="importExcel = true"
        small
        class="float-right"
        dark
        tile
        color="secundary"
      >
        <v-avatar size="20" tile>
          <v-img
            :contain="true"
            :aspect-ratio="1"
            position="center"
            src="@/assets/img/icoExcelWhite.svg"
            class="black--text"
          ></v-img> </v-avatar
        >Importar de excel
      </v-btn>
      </div>
      <div class="titSec">
        General del Protocolo de {{ tipoProtocolo.descripcion }}
      </div>
      <template v-if="!importExcel">
        <div class="blanco">
          <v-row cols>
            <v-col :cols="12" :xs="1" :sm="1" :md="1" :lg="1" :xl="1">
              No
              <v-text-field
                v-model="protocolo.datos_generales.no"
                disabled
              ></v-text-field>
            </v-col>
            <v-col :cols="12" :xs="1" :sm="4" :md="5" :lg="5" :xl="4">
              Nombre del Protocolo
              <span class="tRojo">*</span>
              <v-text-field
                maxlength="50"
                v-model="protocolo.datos_generales.nombre"
                background-color="white"
                hint-align="right"
                :hint="
                  'CARACTERES RESTANTES ' +
                    serviceCommons.remaningCharacters(
                      protocolo.datos_generales.nombre,
                      50
                    )
                "
                :error="$v.protocolo.datos_generales.nombre.$error"
              >
                <template
                  v-if="$v.protocolo.datos_generales.nombre.$error"
                  v-slot:append
                >
                  <v-popover placement="bottom-end" color="red" offset="16">
                    <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                    <template slot="popover">
                      <span
                        @click="$v.protocolo.datos_generales.nombre.$reset"
                        v-close-popover
                      >
                        <span
                          v-if="!$v.protocolo.datos_generales.nombre.required"
                          >¡No te olvides de éste campo!</span
                        >
                      </span>
                    </template>
                  </v-popover>
                </template>
              </v-text-field>
            </v-col>
            <v-col
              v-if="false"
              :cols="12"
              :xs="1"
              :sm="7"
              :md="6"
              :lg="6"
              :xl="7"
            >
              Perteneciente
              <span class="tRojo">*</span>
              <v-radio-group disabled row>
                <v-radio
                  v-for="(itemTipoProtocolo,
                  indexiItemTipoProtocolo) in metadadata.tipos_protocolo"
                  :key="indexiItemTipoProtocolo"
                  :label="itemTipoProtocolo.nombre"
                  :value="itemTipoProtocolo.nombre"
                  color="primary"
                ></v-radio>
              </v-radio-group>
            </v-col>
          </v-row>
        </div>
        <v-text-field
          v-model.trim="search_seccion_text"
          class="float-right pt-0 mt-0"
          clearable
          label="Buscar..."
          type="text"
        >
          <template v-slot:prepend>
            <v-tooltip bottom>
              <template v-slot:activator="{ on }">
                <v-icon v-on="on">mdi-card-search-outline</v-icon>
              </template>
              Buscar
            </v-tooltip>
          </template>
          <template v-slot:append-outer>
            <v-btn
              color="primary"
              small
              @click="search_seccion = search_seccion_text"
              >Buscar</v-btn
            >
          </template>
        </v-text-field>
        <div class="titSec titSec2">
          <span
            class="float-left"
            :class="[{ 'error--text': $v.protocolo.secciones.$error }]"
            >Sección y sus preguntas correspondientes</span
          >
          <template v-if="$v.protocolo.secciones.$error">
            <v-popover
              class="float-left"
              placement="bottom-end"
              color="red"
              offset="16"
            >
              <v-icon color="#fd5151">mdi-alert-circle</v-icon>
              <template slot="popover">
                <span @click="$v.protocolo.secciones.$reset" v-close-popover>
                  <div v-if="!$v.protocolo.secciones.required">
                    *¡Es necesario agregar al menos una sección!
                  </div>
                  <div v-if="$v.protocolo.secciones.$error">
                    *¡Verifica no tenga errores la secciones y preguntas!
                  </div>
                </span>
              </template>
            </v-popover>
          </template>
          <br />
        </div>
        <v-sheet width="100%" class="overflow-y-auto CardScroll">
          <div class="gris overflow-y-auto" style="max-height: 400px; position: relative;">
            <v-overlay
              absolute=""
              :value="working"
            >
            <v-progress-circular color="primary" indeterminate size="40">Trabajando...</v-progress-circular>
            </v-overlay>
            <div>
              
                <template
                  v-for="(itemSeccion, indexItemSeccion) in seccionesFiltered"
                >
                  <div :key="indexItemSeccion" style="min-height: 100px; width:100%"
                    :aria-index="indexItemSeccion"
                    v-intersect="onIntersect"
                    v-if="itemSeccion.show"
                    >
                    <v-card
                      v-if="indexesSecciones.includes(parseInt(indexItemSeccion))"
                      :class="[
                        {
                          'header-admin-error':
                            $v.protocolo.secciones.$each[indexItemSeccion]
                              .$error ||
                            !$v.protocolo.secciones.$each[indexItemSeccion]
                              .preguntas.required
                        }
                      ]"
                      :key="'card' + indexItemSeccion"
                      width="100%"
                      class="mb-2"
                    >
                      <div class="header-admin">
                        <v-btn
                          @click="
                            dialogDelete = true;
                            indexItemSeccionToDelete = indexItemSeccion;
                          "
                          small
                          class="mr-10 mt-5"
                          color="red"
                          fab
                          absolute
                          right
                        >
                          <v-avatar size="25">
                            <v-img
                              :contain="true"
                              :aspect-ratio="1"
                              position="center"
                              src="@/assets/img/delete-white.svg"
                              class="white--text align-end"
                            ></v-img>
                          </v-avatar>
                        </v-btn>
                        <v-btn
                          absolute
                          class="mt-5"
                          right
                          icon
                          @click="itemSeccion.showContentPanel = !itemSeccion.showContentPanel;"
                        >
                          <v-icon>{{
                            itemSeccion.showContentPanel ? "mdi-chevron-up" : "mdi-chevron-down"
                          }}</v-icon>
                        </v-btn>
                        <div>
                          <v-row class="ma-5">
                            <v-col
                              :cols="12"
                              :xs="4"
                              :sm="11"
                              :md="8"
                              :lg="5"
                              :xl="4"
                              class="pa-0 pl-6"
                            >
                              <span
                                :class="[
                                  {
                                    'error--text':
                                      $v.protocolo.secciones.$each[
                                        indexItemSeccion
                                      ].$error ||
                                      !$v.protocolo.secciones.$each[
                                        indexItemSeccion
                                      ].preguntas.required
                                  }
                                ]"
                              >
                                Sección
                                <span class="tRojo">*</span>
                              </span>

                              <template
                                v-if="
                                  $v.protocolo.secciones.$each[indexItemSeccion]
                                    .$error
                                "
                              >
                                <v-popover
                                  class="float-right"
                                  placement="bottom-end"
                                  color="red"
                                  offset="16"
                                >
                                  <v-icon class color="#fd5151"
                                    >mdi-alert-circle</v-icon
                                  >
                                  <template slot="popover">
                                    <span
                                      @click="
                                        $v.protocolo.secciones.$each[
                                          indexItemSeccion
                                        ].preguntas.$reset;
                                      "
                                      v-close-popover
                                    >
                                      <div
                                        v-if="
                                          !$v.protocolo.secciones.$each[
                                            indexItemSeccion
                                          ].preguntas.required
                                        "
                                      >
                                        ¡Es necesario agregar al menos una
                                        pregunta por sección!
                                      </div>
                                      <div
                                        v-if="
                                          $v.protocolo.secciones.$each[
                                            indexItemSeccion
                                          ].$error
                                        "
                                      >
                                        ¡Algún campo de las preguntas contiene
                                        errores!
                                      </div>
                                    </span>
                                  </template>
                                </v-popover>
                              </template>
                              <v-text-field
                                background-color="white"
                                v-model="itemSeccion.datos_generales.nombre"
                                hint-align="right"
                                :hint="
                                  'CARACTERES RESTANTES ' +
                                    serviceCommons.remaningCharacters(
                                      protocolo.datos_generales.nombre,
                                      50
                                    )
                                "
                                :error="
                                  $v.protocolo.secciones.$each[indexItemSeccion]
                                    .datos_generales.nombre.$error
                                "
                              >
                                <template
                                  v-if="
                                    $v.protocolo.secciones.$each[
                                      indexItemSeccion
                                    ].datos_generales.nombre.$error
                                  "
                                  v-slot:append
                                >
                                  <v-popover
                                    placement="bottom-end"
                                    color="red"
                                    offset="16"
                                  >
                                    <v-icon class color="#fd5151"
                                      >mdi-alert-circle</v-icon
                                    >
                                    <template slot="popover">
                                      <span
                                        @click="
                                          $v.protocolo.secciones.$each[
                                            indexItemSeccion
                                          ].datos_generales.nombre.$reset;
                                        "
                                        v-close-popover
                                      >
                                        <span
                                          v-if="
                                            !$v.protocolo.secciones.$each[
                                              indexItemSeccion
                                            ].datos_generales.nombre.required
                                          "
                                          >¡No te olvides de éste campo!</span
                                        >
                                      </span>
                                    </template>
                                  </v-popover>
                                </template>
                              </v-text-field>
                            </v-col>
                          </v-row>
                        </div>
                      </div>
                      <v-expand-transition>
                        <div v-show="itemSeccion.showContentPanel" class="body-admin pa-5">
                          <template
                            v-for="(itemSeccionPregunta,
                            indexItemSeccionPregunta) in itemSeccion.preguntas"
                          >
                            <div
                              style="height : 240px;"
                              :key="'x' + indexItemSeccionPregunta"
                              :aria-index="
                                indexItemSeccion +
                                  ',' +
                                  indexItemSeccionPregunta
                              "
                              v-intersect="onIntersectQuestion"
                            >
                              <div
                                :key="indexItemSeccionPregunta"
                                v-if="
                                  indexesSeccionPregrunta.includes(
                                    indexItemSeccion +
                                      ',' +
                                      indexItemSeccionPregunta
                                  )
                                "
                                :class="[
                                  {
                                    'pading-preg-hija':
                                      itemSeccionPregunta.padre &&
                                      itemSeccionPregunta.padre !== 0
                                  }
                                ]"
                              >
                                <v-btn
                                  @click="
                                    borrarPregunta(
                                      indexItemSeccion,
                                      indexItemSeccionPregunta
                                    )
                                  "
                                  small
                                  class="float-right mt-6"
                                  color="red"
                                  fab
                                >
                                  <v-avatar size="25">
                                    <v-img
                                      :contain="true"
                                      :aspect-ratio="1"
                                      position="center"
                                      src="@/assets/img/delete-white.svg"
                                      class="white--text align-end"
                                    ></v-img>
                                  </v-avatar>
                                </v-btn>
                                <v-row>
                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="1"
                                    :lg="1"
                                    :xl="1"
                                  >
                                    No
                                    <v-text-field
                                      v-model="itemSeccionPregunta.no"
                                      disabled
                                      :value="
                                        parseInt(indexItemSeccionPregunta) + 1
                                      "
                                      placeholder="No"
                                    ></v-text-field>
                                  </v-col>

                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="2"
                                    :lg="1"
                                    :xl="1"
                                  >
                                    Codigo
                                    <span class="tRojo">*</span>
                                    <v-text-field
                                      background-color="white"
                                      v-model.number="
                                        itemSeccionPregunta.codigo
                                      "
                                      placeholder="Codigo"
                                      v-number
                                      :error="
                                        $v.protocolo.secciones.$each[
                                          indexItemSeccion
                                        ].preguntas.$each[
                                          indexItemSeccionPregunta
                                        ].codigo.$error
                                      "
                                    >
                                      <template
                                        v-if="
                                          $v.protocolo.secciones.$each[
                                            indexItemSeccion
                                          ].preguntas.$each[
                                            indexItemSeccionPregunta
                                          ].codigo.$error
                                        "
                                        v-slot:append
                                      >
                                        <v-popover
                                          placement="bottom-end"
                                          color="red"
                                          offset="16"
                                        >
                                          <v-icon class color="#fd5151"
                                            >mdi-alert-circle</v-icon
                                          >
                                          <template slot="popover">
                                            <span
                                              @click="
                                                $v.protocolo.secciones.$each[
                                                  indexItemSeccion
                                                ].preguntas.$each[
                                                  indexItemSeccionPregunta
                                                ].codigo.$reset;
                                              "
                                              v-close-popover
                                            >
                                              <span
                                                v-if="
                                                  !$v.protocolo.secciones.$each[
                                                    indexItemSeccion
                                                  ].preguntas.$each[
                                                    indexItemSeccionPregunta
                                                  ].codigo.required
                                                "
                                                >¡No te olvides de éste
                                                campo!</span
                                              >
                                            </span>
                                          </template>
                                        </v-popover>
                                      </template>
                                    </v-text-field>
                                  </v-col>
                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="3"
                                    :lg="2"
                                    :xl="1"
                                  >
                                    Negocio
                                    <span class="tRojo">*</span>
                                    <v-text-field
                                      background-color="white"
                                      v-model="itemSeccionPregunta.negocio"
                                      placeholder="Negocio"
                                    >
                                      <template
                                        v-if="
                                          $v.protocolo.secciones.$each[
                                            indexItemSeccion
                                          ].preguntas.$each[
                                            indexItemSeccionPregunta
                                          ].negocio.$error
                                        "
                                        v-slot:append
                                      >
                                        <v-popover
                                          placement="bottom-end"
                                          color="red"
                                          offset="16"
                                        >
                                          <v-icon class color="#fd5151"
                                            >mdi-alert-circle</v-icon
                                          >
                                          <template slot="popover">
                                            <span
                                              @click="
                                                $v.protocolo.secciones.$each[
                                                  indexItemSeccion
                                                ].preguntas.$each[
                                                  indexItemSeccionPregunta
                                                ].negocio.$reset;
                                              "
                                              v-close-popover
                                            >
                                              <span
                                                v-if="
                                                  !$v.protocolo.secciones.$each[
                                                    indexItemSeccion
                                                  ].preguntas.$each[
                                                    indexItemSeccionPregunta
                                                  ].negocio.required
                                                "
                                                >¡No te olvides de éste
                                                campo!</span
                                              >
                                            </span>
                                          </template>
                                        </v-popover>
                                      </template>
                                    </v-text-field>
                                  </v-col>

                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="4"
                                    :lg="4"
                                    :xl="2"
                                  >
                                    Pregunta
                                    <span class="tRojo">*</span>
                                    <v-text-field
                                      background-color="white"
                                      v-model="itemSeccionPregunta.pregunta"
                                      placeholder="Pregunta"
                                    >
                                      <template
                                        v-if="
                                          $v.protocolo.secciones.$each[
                                            indexItemSeccion
                                          ].preguntas.$each[
                                            indexItemSeccionPregunta
                                          ].pregunta.$error
                                        "
                                        v-slot:append
                                      >
                                        <v-popover
                                          placement="bottom-end"
                                          color="red"
                                          offset="16"
                                        >
                                          <v-icon class color="#fd5151"
                                            >mdi-alert-circle</v-icon
                                          >
                                          <template slot="popover">
                                            <span
                                              @click="
                                                $v.protocolo.secciones.$each[
                                                  indexItemSeccion
                                                ].preguntas.$each[
                                                  indexItemSeccionPregunta
                                                ].pregunta.$reset;
                                              "
                                              v-close-popover
                                            >
                                              <span
                                                v-if="
                                                  !$v.protocolo.secciones.$each[
                                                    indexItemSeccion
                                                  ].preguntas.$each[
                                                    indexItemSeccionPregunta
                                                  ].pregunta.required
                                                "
                                                >¡No te olvides de éste
                                                campo!</span
                                              >
                                            </span>
                                          </template>
                                        </v-popover>
                                      </template>
                                    </v-text-field>
                                  </v-col>

                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="2"
                                    :lg="2"
                                    :xl="2"
                                  >
                                    Factor crítico
                                    <v-select
                                      background-color="white"
                                      v-model="
                                        itemSeccionPregunta.factorCritico
                                      "
                                      :items="metadadata.factoresCriticos"
                                      placeholder="Factor crítico"
                                    >
                                    </v-select>
                                  </v-col>

                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="2"
                                    :lg="2"
                                    :xl="1"
                                  >
                                    Padre
                                    <span class="tRojo">*</span>
                                    <v-text-field
                                      background-color="white"
                                      v-number
                                      v-model.number="itemSeccionPregunta.padre"
                                      placeholder="Padre"
                                    >
                                      <template
                                        v-if="
                                          $v.protocolo.secciones.$each[
                                            indexItemSeccion
                                          ].preguntas.$each[
                                            indexItemSeccionPregunta
                                          ].padre.$error
                                        "
                                        v-slot:append
                                      >
                                        <v-popover
                                          placement="bottom-end"
                                          color="red"
                                          offset="16"
                                        >
                                          <v-icon class color="#fd5151"
                                            >mdi-alert-circle</v-icon
                                          >
                                          <template slot="popover">
                                            <span
                                              @click="
                                                $v.protocolo.secciones.$each[
                                                  indexItemSeccion
                                                ].preguntas.$each[
                                                  indexItemSeccionPregunta
                                                ].padre.$reset;
                                              "
                                              v-close-popover
                                            >
                                              <span
                                                v-if="
                                                  !$v.protocolo.secciones.$each[
                                                    indexItemSeccion
                                                  ].preguntas.$each[
                                                    indexItemSeccionPregunta
                                                  ].padre.required
                                                "
                                                >¡No te olvides de éste
                                                campo!</span
                                              >
                                            </span>
                                          </template>
                                        </v-popover>
                                      </template>
                                    </v-text-field>
                                  </v-col>

                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="3"
                                    :lg="2"
                                    :xl="2"
                                  >
                                    Tipo de Respuesta
                                    <span class="tRojo">*</span>
                                    <v-select
                                      background-color="white"
                                      v-model="
                                        itemSeccionPregunta.tipoRespuesta
                                      "
                                      :items="metadadata.tiposRespuestas"
                                      placeholder="Tipo de Respuesta"
                                    >
                                      <template
                                        v-if="
                                          $v.protocolo.secciones.$each[
                                            indexItemSeccion
                                          ].preguntas.$each[
                                            indexItemSeccionPregunta
                                          ].tipoRespuesta.$error
                                        "
                                        v-slot:append-outer
                                      >
                                        <v-popover
                                          placement="bottom-end"
                                          color="red"
                                          offset="16"
                                        >
                                          <v-icon class color="#fd5151"
                                            >mdi-alert-circle</v-icon
                                          >
                                          <template slot="popover">
                                            <span
                                              @click="
                                                $v.protocolo.secciones.$each[
                                                  indexItemSeccion
                                                ].preguntas.$each[
                                                  indexItemSeccionPregunta
                                                ].tipoRespuesta.$reset;
                                              "
                                              v-close-popover
                                            >
                                              <span
                                                v-if="
                                                  !$v.protocolo.secciones.$each[
                                                    indexItemSeccion
                                                  ].preguntas.$each[
                                                    indexItemSeccionPregunta
                                                  ].tipoRespuesta.required
                                                "
                                                >¡No te olvides de éste
                                                campo!</span
                                              >
                                            </span>
                                          </template>
                                        </v-popover>
                                      </template>
                                    </v-select>
                                  </v-col>

                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="3"
                                    :lg="2"
                                    :xl="2"
                                  >
                                    Opciones combo
                                    <v-text-field
                                      background-color="white"
                                      v-model="
                                        itemSeccionPregunta.opcionesCombo
                                      "
                                      placeholder="Opciones combo"
                                    ></v-text-field>
                                  </v-col>

                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="2"
                                    :lg="2"
                                    :xl="1"
                                  >
                                    Cumplimiento
                                    <v-select
                                      background-color="white"
                                      v-model="itemSeccionPregunta.cumplimiento"
                                      :items="metadadata.opcionesCumplimiento"
                                      placeholder="Cumplimiento"
                                    >
                                    </v-select>
                                  </v-col>

                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="2"
                                    :lg="2"
                                    :xl="1"
                                  >
                                    Valor
                                    <span class="tRojo">*</span>
                                    <v-text-field
                                      background-color="white"
                                      v-number-decimal
                                      v-model="
                                        itemSeccionPregunta.valorPonderacion
                                      "
                                      placeholder="Valor"
                                    >
                                      <template
                                        v-if="
                                          $v.protocolo.secciones.$each[
                                            indexItemSeccion
                                          ].preguntas.$each[
                                            indexItemSeccionPregunta
                                          ].valorPonderacion.$error
                                        "
                                        v-slot:append
                                      >
                                        <v-popover
                                          placement="bottom-end"
                                          color="red"
                                          offset="16"
                                        >
                                          <v-icon class color="#fd5151"
                                            >mdi-alert-circle</v-icon
                                          >
                                          <template slot="popover">
                                            <span
                                              @click="
                                                $v.protocolo.secciones.$each[
                                                  indexItemSeccion
                                                ].preguntas.$each[
                                                  indexItemSeccionPregunta
                                                ].valorPonderacion.$reset;
                                              "
                                              v-close-popover
                                            >
                                              <span
                                                v-if="
                                                  !$v.protocolo.secciones.$each[
                                                    indexItemSeccion
                                                  ].preguntas.$each[
                                                    indexItemSeccionPregunta
                                                  ].valorPonderacion.required
                                                "
                                                >¡No te olvides de éste
                                                campo!</span
                                              >
                                            </span>
                                          </template>
                                        </v-popover>
                                      </template>
                                    </v-text-field>
                                  </v-col>
                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="3"
                                    :lg="2"
                                    :xl="1"
                                  >
                                    Comentario
                                    <v-select
                                      background-color="white"
                                      v-model="itemSeccionPregunta.comentario"
                                      :items="metadadata.opcionesComentarios"
                                      placeholder="Comentario"
                                    >
                                    </v-select>
                                  </v-col>

                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="2"
                                    :lg="2"
                                    :xl="1"
                                  >
                                    Evidencia
                                    <v-select
                                      background-color="white"
                                      v-model="itemSeccionPregunta.evidencia"
                                      :items="metadadata.opcionesEvidencias"
                                      placeholder="Evidencia"
                                    >
                                    </v-select>
                                  </v-col>

                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="3"
                                    :lg="2"
                                    :xl="2"
                                  >
                                    Tipo de Evidencia
                                    <v-select
                                      background-color="white"
                                      v-model="
                                        itemSeccionPregunta.tipoEvidencia
                                      "
                                      :items="
                                        metadadata.opcionesTiposEvidencias
                                      "
                                      placeholder="Tipo de Evidencia"
                                    >
                                    </v-select>
                                  </v-col>
                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="2"
                                    :lg="1"
                                    :xl="1"
                                  >
                                    SI-V
                                    <v-select
                                      background-color="white"
                                      v-model="itemSeccionPregunta.plantillaSi"
                                      :items="metadadata.plantillasEvidencias"
                                      placeholder="SI-V"
                                    >
                                    </v-select>
                                  </v-col>

                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="2"
                                    :lg="1"
                                    :xl="1"
                                  >
                                    NO-F
                                    <v-select
                                      background-color="white"
                                      v-model="itemSeccionPregunta.plantillaNo"
                                      :items="metadadata.plantillasEvidencias"
                                      placeholder="NO-F"
                                    >
                                    </v-select>
                                  </v-col>

                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="3"
                                    :lg="3"
                                    :xl="1"
                                  >
                                    Definición
                                    <v-text-field
                                      background-color="white"
                                      v-model="itemSeccionPregunta.definicion"
                                      placeholder="Definición"
                                    ></v-text-field>
                                  </v-col>

                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="3"
                                    :lg="2"
                                    :xl="1"
                                  >
                                    Zona
                                    <span class="tRojo">*</span>
                                    <v-select
                                      background-color="white"
                                      v-model="itemSeccionPregunta.zona"
                                      :items="metadadata.opcionesZonas"
                                      placeholder="Zona"
                                    >
                                      <template
                                        v-if="
                                          $v.protocolo.secciones.$each[
                                            indexItemSeccion
                                          ].preguntas.$each[
                                            indexItemSeccionPregunta
                                          ].zona.$error
                                        "
                                        v-slot:append-outer
                                      >
                                        <v-popover
                                          placement="bottom-end"
                                          color="red"
                                          offset="16"
                                        >
                                          <v-icon class color="#fd5151"
                                            >mdi-alert-circle</v-icon
                                          >
                                          <template slot="popover">
                                            <span
                                              @click="
                                                $v.protocolo.secciones.$each[
                                                  indexItemSeccion
                                                ].preguntas.$each[
                                                  indexItemSeccionPregunta
                                                ].zona.$reset;
                                              "
                                              v-close-popover
                                            >
                                              <span
                                                v-if="
                                                  !$v.protocolo.secciones.$each[
                                                    indexItemSeccion
                                                  ].preguntas.$each[
                                                    indexItemSeccionPregunta
                                                  ].zona.required
                                                "
                                                >¡No te olvides de éste
                                                campo!</span
                                              >
                                            </span>
                                          </template>
                                        </v-popover>
                                      </template>
                                    </v-select>
                                  </v-col>

                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="4"
                                    :lg="2"
                                    :xl="1"
                                  >
                                    Responsable
                                    <v-text-field
                                      background-color="white"
                                      v-model="itemSeccionPregunta.responsable"
                                      placeholder="Responsable"
                                    ></v-text-field>
                                  </v-col>

                                  <v-col
                                    :cols="12"
                                    :xs="12"
                                    :sm="6"
                                    :md="2"
                                    :lg="1"
                                    :xl="1"
                                  >
                                    SLA
                                    <v-text-field
                                      v-number
                                      background-color="white"
                                      v-model="itemSeccionPregunta.sla"
                                      placeholder="SLA"
                                    ></v-text-field>
                                  </v-col>
                                </v-row>
                                <v-divider></v-divider>
                              </div>
                            </div>
                            <!--</v-skeleton-loader>-->
                          </template>
                          <v-row>
                            <v-col
                              :offset-md="1"
                              :offset-lg="1"
                              :offset-xl="3"
                              :xs="12"
                              :sm="12"
                              :md="10"
                              :lg="10"
                              :xl="6"
                            >
                              <div class="btnAgregar">
                                <v-btn
                                  @click="agregarPregunta(indexItemSeccion)"
                                  small
                                  class="black--text"
                                  dark
                                  tile
                                  color="white"
                                >
                                  <v-avatar size="20" tile>
                                    <v-img
                                      :contain="true"
                                      :aspect-ratio="1"
                                      position="center"
                                      src="@/assets/img/icoSimpleAgregar.svg"
                                      class="black--text"
                                    ></v-img> </v-avatar
                                  >Añadir nueva pregunta
                                </v-btn>
                              </div>
                            </v-col>
                          </v-row>
                        </div>
                      </v-expand-transition>
                    </v-card>
                    </div>
                </template>
            </div>
          </div>
        </v-sheet>
        <v-row>
          <v-col
            :offset-md="1"
            :offset-lg="1"
            :offset-xl="3"
            :xs="12"
            :sm="12"
            :md="10"
            :lg="10"
            :xl="6"
          >
            <div class="btnAgregar">
              <v-btn
                @click="agregarSeccion"
                small
                class="black--text"
                dark
                tile
                color="white"
              >
                <v-avatar size="20" tile>
                  <v-img
                    :contain="true"
                    :aspect-ratio="1"
                    position="center"
                    src="@/assets/img/icoSimpleAgregar.svg"
                    class="black--text"
                  ></v-img> </v-avatar
                >Añadir nueva sección
              </v-btn>
            </div>
          </v-col>
        </v-row>
        <div class="btnCenter">
          <v-btn
            class="mr-6"
            :class="[{ desac: !hasGlobalChanges }]"
            @click="dialogCancel = true"
            depressed
            dark
            tile
            color="secundary"
            >Cancelar cambios</v-btn
          >
          <v-btn
            :class="[
              {desac : savingProtocolo},
              { desac: !hasGlobalChanges },
              { 'validation-error-btn': $v.$error }
            ]"
            depressed
            dark
            tile
            :color="$v.$error ? 'red' : 'primary'"
            @click="enviarProtocolo"
            >Guardar cambios</v-btn
          >
        </div>
      </template>
      <template v-if="importExcel">
        <GestionProtocoloCargaExcel :data="$data" :visualizarInfo="visualizarInfo" />
      </template>
      <template>
        <v-dialog v-model="dialogErrorValidation" persistent max-width="600px">
          <v-card>
            <v-card-title>
              <div class="titModal titModaleError">
                <strong>¡Oh oh!</strong>
                Tienes algunos conflictos de validación
              </div>
            </v-card-title>
            <v-card-text>
              ¡No hay de que preocuparse! Solo tinenes que corregirlos.
            </v-card-text>
            <v-card-actions>
              <v-row justify="center" style="margin-right:0px">
                <v-btn
                  class="ma-2"
                  dark
                  tile
                  depressed
                  color="error"
                  @click="dialogErrorValidation = false"
                  >¡De acuerdo!</v-btn
                >
              </v-row>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-dialog v-model="dialogCancel" persistent max-width="600px">
          <v-card>
            <v-card-title>
              <div class="titModal">
                ¿Seguro que deseas
                <strong>cancelar</strong> los cambios realizados?
                <v-btn
                  color="secondary"
                  icon
                  dark
                  @click="dialogCancel = false"
                  style="position: absolute;right: 0px;top: 0px;"
                >
                  <v-icon>mdi-close</v-icon>
                </v-btn>
              </div>
            </v-card-title>
            <v-card-text></v-card-text>
            <v-card-actions>
              <v-row justify="center" style="margin-right:0px">
                <v-btn
                  class="ma-2"
                  dark
                  tile
                  depressed
                  color="secondary"
                  @click="dialogCancel = false"
                  >No, cancelar</v-btn
                >
                <v-btn
                  class="ma-2"
                  depressed
                  dark
                  tile
                  color="primary"
                  @click="cancelGlobalChanges()"
                  >Si, continuar</v-btn
                >
              </v-row>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-dialog v-model="dialogDelete" persistent max-width="600px">
          <v-card>
            <v-card-title>
              <div class="titModal">
                <strong>¿Seguro que deseas eliminar esta sección?</strong>
              </div>
            </v-card-title>
            <v-card-text>
              <div class>
                La sección
                <strong v-if="protocolo.secciones[indexItemSeccionToDelete]">
                  {{
                    protocolo.secciones[indexItemSeccionToDelete]
                      .datos_generales.nombre
                  }}
                </strong>
                <template v-if="protocolo.secciones[indexItemSeccionToDelete]">
                  tiene un total de
                  {{ totalPreguntasSeccionAEliminar }}
                  preguntas asignadas.
                </template>
              </div>
            </v-card-text>
            <v-card-actions>
              <v-row justify="center" style="margin-right:0px">
                <v-btn
                  class="ma-2"
                  dark
                  tile
                  depressed
                  color="secondary"
                  @click="dialogDelete = false"
                  >No, cancelar</v-btn
                >
                <v-btn
                  class="ma-2"
                  depressed
                  dark
                  tile
                  color="primary"
                  @click="deleteTempSeccion"
                  >Si, continuar</v-btn
                >
              </v-row>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-dialog v-model="dialogSave" persistent max-width="600px">
          <v-card>
            <v-card-title>
              <div class="titModal">
                ¡Se han
                <strong>guardado los cambios de manera exitosa!</strong>
              </div>
            </v-card-title>
            <v-card-text></v-card-text>
            <v-card-actions>
              <v-row justify="center" style="margin-right:0px">
                <v-btn
                  :to="toBack"
                  class="ma-2"
                  depressed
                  dark
                  tile
                  color="primary"
                  @click="dialogSave = false"
                  >Regresar a Protocolos</v-btn
                >
              </v-row>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-dialog v-model="dialogErrorSave" persistent max-width="600px">
          <v-card>
            <v-card-title>
              <div class="titModal titModaleError">
                <strong>¡Oh oh!</strong>
                No logramos guardar tus datos
              </div>
            </v-card-title>
            <v-card-text>
              ¡No hay de que preocuparse! Ya estamos trabajando en ello,
              estaremos de regreso pronto.
            </v-card-text>
            <v-card-actions>
              <v-row justify="center" style="margin-right:0px">
                <v-btn
                  class="ma-2"
                  dark
                  tile
                  depressed
                  color="error"
                  @click="dialogErrorSave = false"
                  >¡De acuerdo!</v-btn
                >
              </v-row>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-dialog v-model="dialogErrorReading" persistent max-width="600px">
          <v-card>
            <v-card-title>
              <div class="titModal titModaleError">
                <strong>¡Oh oh!</strong>
                No logramos recuperar tus datos
              </div>
            </v-card-title>
            <v-card-text>
              ¡No hay de que preocuparse! Ya estamos trabajando en ello,
              estaremos de regreso pronto.
            </v-card-text>
            <v-card-actions>
              <v-row justify="center" style="margin-right:0px">
                <v-btn
                  class="ma-2"
                  dark
                  tile
                  depressed
                  color="error"
                  @click="dialogErrorReading = false"
                  >¡De acuerdo!</v-btn
                >
              </v-row>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </template>
    </div>
  </div>
</template>
<style scoped>
.pading-preg-hija {
  padding-left: 30px;
  background-color: #e2e2e2;
}
.header-general {
  border-top: 3px solid black;
  background-color: rgb(250, 249, 249);
}
.header-admin-error {
  border: 1px solid #fd5151;
}
.header-admin {
  background-color: rgb(228, 228, 228);
  height: 100px;
}
.body-admin {
  background-color: rgb(250, 249, 249);
}
.seccion-admin {
  border-bottom: 1px solid rgb(218, 215, 215);
}
</style>
<style>
.custom-skeleton-question
  div
  .v-skeleton-loader__table-row.v-skeleton-loader__bone {
  background: rgb(228, 228, 228) !important;
  height: 80px !important;
}
.custom-skeleton-question.theme--light.v-skeleton-loader
  .v-skeleton-loader__bone::after {
  background: linear-gradient(
    90deg,
    transparent,
    rgba(255, 255, 255, 0.3),
    #0000000d
  ) !important;
}
.custom-skeleton-question
  .v-skeleton-loader__table-cell.v-skeleton-loader__bone {
  width: 300px;
}
.custom-skeleton-question .v-skeleton-loader__text.v-skeleton-loader__bone {
  background: rgb(255, 255, 255) !important;
  height: 40px;
}
.custom-skeleton-seccion
  .v-skeleton-loader__card-heading.v-skeleton-loader__bone {
  background: rgb(228, 228, 228) !important;
  height: 117px !important;
}
.custom-skeleton-seccion
  div
  .v-skeleton-loader__heading.v-skeleton-loader__bone {
  height: 40px !important;
}
.custom-skeleton-seccion.theme--light.v-skeleton-loader
  .v-skeleton-loader__bone::after {
  background: linear-gradient(
    90deg,
    transparent,
    rgba(255, 255, 255, 0.3),
    #0000000d
  ) !important;
}
.custom-skeleton-seccion.theme--light.v-skeleton-loader
  .v-skeleton-loader__heading {
  background: rgb(255, 255, 255) !important;
}
</style>
<script>
import store from "@/store";
import router from "@/router";
import GestionProtocoloCargaExcel from "@/views/secure/modelo-franquicia/protocolos/GestionProtocoloCargaExcel.vue";
//import { Scroll } from "vuetify/lib/directives";
const serviceCommons = store.state.serviceCommons;
const axiosChecklist = store.state.axiosChecklist;
import { required } from "vuelidate/lib/validators";
const pregunta_template = {
  no: null,
  codigo: null,
  negocio: null,
  pregunta: null,
  factorCritico: null,
  padre: null,
  tipoRespuesta: null,
  opcionesCombo: null,
  cumplimiento: null,
  valorPonderacion: null,
  comentario: null,
  evidencia: null,
  tipoEvidencia: null,
  plantillaSi: null,
  plantillaNo: null,
  definicion: null,
  zona: null,
  responsable: null,
  sla: null
};
const secciones_template = {
  datos_generales: {
    nombre: null,
    sub_seccion: null
  },
  preguntas: [],
  showContentPanel : false
};
const metadadata = {
  tipos_protocolo: [
    { nombre: "Certificación de Calidad" },
    { nombre: "Infraestructura" }
  ],
  factoresCriticos: ["Ninguno", "Bajo", "Medio", "Alto", "Imperdonable"],
  tiposRespuestas: [
    "SI - NO",
    "Verdadero - Falso",
    "SI - NO - NE",
    "Texto",
    "Numérica",
    "Combo",
    "OK"
  ],
  opcionesCumplimiento: ["NA", "SI", "NO", "VERDADERO", "FALSO"],
  opcionesComentarios: ["SI", "NO"],
  opcionesEvidencias: ["SI", "NO"],
  opcionesTiposEvidencias: ["Foto", "Video"],
  plantillasEvidencias: ["Ninguno", "A", "B", "C", "D"],
  opcionesZonas: [
    "Ninguno",
    "EKT",
    "PP",
    "AREAS",
    "GENERALES",
    "CYC",
    "BAZ",
    "01. Exterior",
    "02. Cajeros automáticos",
    "03. Piso de venta Elektra",
    "04. Baños",
    "05. Comedor",
    "06. Lockers",
    "07. Piso bancario",
    "08. Archiveros",
    "09. Site",
    "10. Presta Prenda"
  ]
};
export default {
  name: "Component-GestionProtocolos",
  components: {
    GestionProtocoloCargaExcel
  },
  data() {
    return {
      dialogErrorValidation: false,
      dialogDelete: false,
      dialogCancel: false,
      importExcel: false,
      dialogSave: false,
      dialogErrorSave: false,
      dialogErrorReading : false,
      working: false,
      savingProtocolo : false,
      indexItemSeccionToDelete: null,
      indexSeccionPanelExpanded: null,
      offsetTop: 0,
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Modelo de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia"
          }
        },
        {
          text: "Protocolos",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia_home_protocolos"
          }
        }
      ],
      toBack: null,
      search_seccion_text: null,
      search_seccion: null,
      tipoProtocolo: {
        id_ambiente: null,
        id_tipo_protocolo: null,
        descripcion: null
      },
      protocolo: {
        datos_generales: {
          no: null,
          tipo_protocolo: null,
          nombre: null,
          idChecklist: null
        },
        secciones: []
      },
      protocoloBackup: {
        datos_generales: {
          no: null,
          tipo_protocolo: null,
          nombre: null,
          idChecklist: null
        },
        secciones: []
      },
      indexesSecciones: [],
      indexesSeccionPregrunta: [],
      seccionesExpanded:[]
    };
  },
  computed: {
    textoGestionProtocolo() {
      let text;
      if (this.tipoProtocolo) {
        if (
          this.protocolo &&
          this.protocolo.datos_generales &&
          this.protocolo.datos_generales.no
        ) {
          text = "Editanto un protocolo";
        } else {
          text = "Creando un protocolo";
        }
      }
      return text;
    },
    hasGlobalChanges() {
      if (this.protocoloBackup && this.protocolo) {
        let protocoloBackup = JSON.parse(JSON.stringify(this.protocoloBackup));
        protocoloBackup.secciones.forEach(itemSeccion => {
          delete itemSeccion.show;
          delete itemSeccion.showContentPanel;
        });
        const originalValue = JSON.stringify(protocoloBackup).replace(
          /"/g,
          ""
        );
        let protocolo = JSON.parse(JSON.stringify(this.protocolo));
        protocolo.secciones.forEach(itemSeccion => {
          delete itemSeccion.show;
          delete itemSeccion.showContentPanel;
        });
        let currentValue = JSON.stringify(protocolo).replace(/"/g, "");
        return originalValue !== currentValue;
      } else {
        return this.protocolo.datos_generales.no === undefined;
      }
    },
    seccionesFiltered() {
      this.startStatusWorking();
      let seccionesProtocolo = this.protocolo.secciones;
      if(seccionesProtocolo.length===0){
        this.stopStatusWorking();
      }
      return seccionesProtocolo.filter((itemSeccion, indexItemSeccion) => {
        if(indexItemSeccion===seccionesProtocolo.length-1){
          this.stopStatusWorking();
        }
        if (this.search_seccion && this.search_seccion !== "") {
          if (
            !itemSeccion.datos_generales.nombre
              .toLowerCase()
              .includes(this.search_seccion.toLowerCase())
          ) {
            itemSeccion.show = false;
          }
          return itemSeccion;
        } else {
          itemSeccion.show = true;
          return itemSeccion;
        }
      });
    },
    serviceCommons() {
      return serviceCommons;
    },
    metadadata() {
      return metadadata;
    },
    totalPreguntasSeccionAEliminar() {
      return this.protocolo.secciones[this.indexItemSeccionToDelete].preguntas
        .length;
    },
    isDataTemp(){
      return localStorage.getItem("dataTemp")!==undefined;
    }
  },
  validations: {
    protocolo: {
      datos_generales: {
        nombre: {
          required
        }
      },
      secciones: {
        required,
        $each: {
          datos_generales: {
            nombre: {
              required
            }
          },
          preguntas: {
            required,
            $each: {
              no: {
                required
              },
              codigo: {
                required
              },
              negocio: {
                required
              },
              pregunta: {
                required
              },
              padre: {
                required
              },
              tipoRespuesta: {
                required
              },
              valorPonderacion: {
                required
              },
              zona: {
                required
              }
            }
          }
        }
      }
    }
  },
  methods: {
    startStatusWorking(){
      this.working = true;
    },
    stopStatusWorking(){
      this.working = false;
    },  
    onIntersectQuestion(entries, observer, isIntersecting) {
      let element = entries[0].target;
      const ariaIndex = element.getAttribute("aria-index");
      if (isIntersecting) {
        this.indexesSeccionPregrunta.push(ariaIndex);
      } else {
        this.indexesSeccionPregrunta = this.indexesSeccionPregrunta.filter(
          itemSeccionPregunta => itemSeccionPregunta !== ariaIndex
        );
      }
    },
    onIntersect(entries, observer, isIntersecting) {
      let element = entries[0].target;
      const indexIntersect = parseInt(element.getAttribute("aria-index"));
      if (isIntersecting) {
        this.indexesSecciones.push(indexIntersect);
      } else {
        this.indexesSecciones = this.indexesSecciones.filter(
          itemSeccion => itemSeccion !== indexIntersect
        );
      }
    },
    visualizarInfo(dataTemp) {
      this.working = true;
      setTimeout(() => {
        if (dataTemp.type === "click") {
          if(this.isDataTemp){
            dataTemp = JSON.parse(localStorage.getItem("dataTemp"));
          }
        }
        if(dataTemp){
          this.protocolo = dataTemp;
        }
      }, 1000);
    },
    initValues() {
      const tipoProtocolo = this.$route.params.tipo_protocolo;
      let id_ambiente;
      if (this.$route.params.protocolo) {
        const protocolo = this.serviceCommons.base64ToObject(
          this.$route.params.protocolo
        );
        this.protocolo.datos_generales.no = protocolo.id_tab;
        id_ambiente = protocolo.id_ambiente;
      }
      if (tipoProtocolo) {
        if (tipoProtocolo === "aseguramiento-calidad") {
          this.toBack = {
            name: "modelo_franquicia_protocolos",
            params: {
              tipo_protocolo: "aseguramiento-calidad"
            }
          };
          this.breadcrumbs.push({
            text: "Certificación de Calidad",
            disabled: false,
            exact: true,
            to: this.toBack
          });
          this.setProtocoloTipo(2, "Certificación de Calidad", id_ambiente);
        } else if (tipoProtocolo === "infraestructura") {
          this.toBack = {
            name: "modelo_franquicia_protocolos",
            params: {
              tipo_protocolo: "infraestructura"
            }
          };
          this.breadcrumbs.push({
            text: "Infraestructura",
            disabled: false,
            exact: true,
            to: this.toBack
          });
          this.setProtocoloTipo(1, "Infraestructura", id_ambiente);
        } else {
          router.push({ name: "modelo_franquicia_protocolos_404" });
        }
        if (this.protocolo.datos_generales.no) {
          this.breadcrumbs.push({
            text: "Edicion",
            disabled: true
          });
        } else {
          this.breadcrumbs.push({
            text: "Nuevo",
            disabled: true
          });
        }
      }
    },
    setProtocoloTipo(id_tipo_protocolo, descripcion, id_ambiente) {
      this.tipoProtocolo = {
        id_tipo_protocolo,
        descripcion,
        id_ambiente
      };
      this.protocolo.datos_generales.tipo_protocolo = descripcion;
      this.protocoloBackup = JSON.parse(JSON.stringify(this.protocolo));
    },
    deleteTempSeccion() {
      this.protocolo.secciones = this.protocolo.secciones.filter(
        (itemSeccion, indexItemSeccion) => {
          if (indexItemSeccion !== this.indexItemSeccionToDelete) {
            return itemSeccion;
          }
        }
      );
      this.indexItemSeccionToDelete = null;
      this.dialogDelete = false;
    },
    agregarPregunta(indexItemSeccion) {
      const preguntaTemplate = JSON.parse(JSON.stringify(pregunta_template));
      this.protocolo.secciones[indexItemSeccion].preguntas.push(
        preguntaTemplate
      );
      this.reindexarSeccion(indexItemSeccion);
    },
    agregarSeccion() {
      const seccionTemplate = JSON.parse(JSON.stringify(secciones_template));
      this.protocolo.secciones.push(seccionTemplate);
    },
    reindexarSeccion(indexItemSeccion) {
      this.protocolo.secciones[
        indexItemSeccion
      ].preguntas = this.protocolo.secciones[indexItemSeccion].preguntas.filter(
        (itemSeccionPregunta, indexItemSeccionPregunta) => {
          itemSeccionPregunta.no = indexItemSeccionPregunta + 1;
          return itemSeccionPregunta;
        }
      );
    },
    borrarPregunta(indexItemSeccion, indexItemSeccionPreguntaIn) {
      this.protocolo.secciones[
        indexItemSeccion
      ].preguntas = this.protocolo.secciones[indexItemSeccion].preguntas.filter(
        (itemSeccionPregunta, indexItemSeccionPregunta) => {
          if (indexItemSeccionPregunta !== indexItemSeccionPreguntaIn) {
            return itemSeccionPregunta;
          }
        }
      );
      this.reindexarSeccion(indexItemSeccion);
    },
    enviarProtocolo() {
      this.protocolo = JSON.parse(JSON.stringify(this.protocolo));
      this.$v.$touch();
      if (!this.$v.$invalid) {
        this.savingProtocolo = true;
        const self = this;
        let formData = new FormData();
        formData.append("JSON", JSON.stringify(this.protocolo));
        formData.append(
          "tipoCarga",
          this.protocolo.datos_generales.tipo_protocolo
        );
        axiosChecklist
          .post(
            "/consultaChecklistAdminService/postAltaProtocolos.json",
            formData,
            {
              headers: {
                "Content-Type": "text/plain"
              }
            }
          )
          .then(response => {
            if (response) {
              if (response.data.ALTA) {
                self.setProtocolo(this.protocolo);
                self.dialogSave = true;
              } else {
                self.dialogErrorSave = true;
              }
            }
          })
          .catch(error => {
            console.log(error);
          })
          .finally(function() {
            this.savingProtocolo = false;
          });
      } else {
        this.protocolo = JSON.parse(JSON.stringify(this.protocolo));
        this.dialogErrorValidation = true;
      }
    },
    getProtocolo() {
      const self = this;
      let urlGetProtocolo;
      if (this.tipoProtocolo.id_ambiente === 1) {
        urlGetProtocolo =
          "/consultaChecklistAdminService/getRetornaProtocoloBaseProduccion.json?idProtocolo=" +
          this.protocolo.datos_generales.no +
          "&tipoCarga=" +
          this.tipoProtocolo.id_tipo_protocolo;
      } else {
        urlGetProtocolo =
          "/consultaChecklistAdminService/getRetornaProtocoloBaseTest.json?idProtocolo=" +
          this.protocolo.datos_generales.no +
          "&tipoCarga=" +
          this.tipoProtocolo.id_tipo_protocolo;
      }
      axiosChecklist
        .post(urlGetProtocolo)
        .then(response => {
          if (response) {
            //Validar Respuesta
            if (response.data) {
              response.data.datos_generales.no =
                self.protocolo.datos_generales.no;
              self.setProtocolo(response.data);
            }else{
              self.dialogErrorReading = true;
            }
          }
        })
        .catch(error => {
          alert(error);
        })
        .finally(function() {});
    },
    setProtocolo(data) {
      this.protocoloBackup = JSON.parse(JSON.stringify(data));
      data.secciones.forEach(indexItemSeccion=>{
        indexItemSeccion.showContentPanel = false;
      });
      this.visualizarInfo(data);
    },
    cancelGlobalChanges() {
      this.protocolo = JSON.parse(JSON.stringify(this.protocoloBackup));
      this.dialogCancel = false;
      this.$v.$reset();
    }
  },
  created() {
    this.initValues();
    if (this.$route.params.protocolo) {
      this.getProtocolo();
    }
  },
  beforeRouteLeave: function(to, from, next) {
    if (this.hasGlobalChanges) {
      const answer = window.confirm(
        "Desea salir, sabiendo que sus cambios previamente realizados se perderán…?"
      );
      if (answer) {
        next();
      } else {
        next(false);
      }
    } else {
      next();
    }
  }
};
</script>
